module TinyFPGA_A2 ( 
//RJA made lower pins A2 output for P2 input and then upper pins A2 input for P2 output
  output p2pin0,
  output p2pin1,
  output p2pin2,
  output p2pin3,
  output p2pin4,
  output p2pin5,
  output pin7_done,
  output pin8_pgmn,
  output p2pin6,
  output p2pin7,
  input p2pin8,
  //inout pin12_tdo,
  //inout pin13_tdi,
  //inout pin14_tck,
  //inout pin15_tms,
  input p2pin9,
  input p2pin10,
  input p2pin11,
  input p2pin12,
  input p2pin13,
  input p2pin14, 
  input p2pin15
);

  // left side of board
  //assign p2pin0 = 1'bz;
  //assign p2pin1 = 1'bz;
  //assign p2pin2= 1'bz;
  //assign p2pin3 = 1'bz;
  //assign p2pin4= 1'bz;
  //assign p2pin5= 1'bz;
  assign pin7_done = 1'bz;
  assign pin8_pgmn = 1'bz;
  //assign p2pin6 = 1'bz;
  //assign p2pin7 = 1'bz;
  //assign p2pin8 = 1'bz;
  
  // right side of board
  //assign pin12_tdo = 1'bz;
  //assign pin13_tdi = 1'bz;
  //assign pin14_tck = 1'bz;
  //assign pin15_tms = 1'bz;
  //assign p2pin9 = 1'bz;
  //assign p2pin10 = 1'bz;
  //assign p2pin11 = 1'bz;
  //assign p2pin12 = 1'bz;
  //assign p2pin13 = 1'bz;
  //assign p2pin14 = 1'bz;
  //assign p2pin15 = 1'bz;
  
  //Add blink
  wire clk;
  
  OSCH #(
    .NOM_FREQ("2.08")
	//.NOM_FREQ("133")
  ) internal_oscillator_inst (
    .STDBY(1'b0), 
    .OSC(clk)
  ); 
  
  reg [23:0] led_timer;
  
  always @(posedge clk) begin
    led_timer <= led_timer + 1; 
  end
  
  
  //RJA extending output from 3 to 8 bits
  assign p2pin7 = led_timer[23];
  assign p2pin6 = led_timer[22];
  assign p2pin5 = led_timer[21];
  
  parameter BUSWIDTH = 4;  //4-bit bus
  

  
  //reg [BUSWIDTH:0] r_ADD_1 = 0;
  //reg [BUSWIDTH:0] r_ADD_2 = 0;
  wire [BUSWIDTH+1:0]  w_RESULT;
   
  ripple_carry_adder #(.WIDTH(BUSWIDTH+1)) ripple_carry_inst
    (
     //.i_add_term1(r_ADD_1),
     //.i_add_term2(r_ADD_2),
	 .i_add_term1({p2pin11,p2pin10,p2pin9,p2pin8}),
	 .i_add_term2({p2pin15,p2pin14,p2pin13,p2pin12}),
     .o_result(w_RESULT)
     );
  
  //assign p2pin8 = r_ADD_1[0];
  //assign p2pin9 = r_ADD_1[1];
  //assign p2pin10 = r_ADD_1[2];
  //assign p2pin11 = r_ADD_1[3];
  
  //assign p2pin12 = r_ADD_2[0];
  //assign p2pin13 = r_ADD_2[1];
  //assign p2pin14 = r_ADD_2[2];
  //assign p2pin15 = r_ADD_2[3];
  
  assign p2pin0 = w_RESULT[0];
  assign p2pin1 = w_RESULT[1];
  assign p2pin2 = w_RESULT[2];
  assign p2pin3 = w_RESULT[3];
  assign p2pin4 = w_RESULT[4];
 

  

endmodule
